<?php
/**
 * ShowAuditTrail shows the audit trail for the current item
 */

Yii::import('zii.widgets.CPortlet');

class ShowAuditTrail extends CPortlet
{
	/**
	 * @var CActiveRecord the model you want to use with this field
	 */
	public $model;

	/**
	 * @var boolean whether or not to show the widget
	 */
	public $visible = true;

	/**
	 * Sets the title of the portlet
	 */
	public function init() {
		$this->title = "Audit Trail For " . get_class($this->model) . " " . $this->model->id;
		parent::init();
	}

	/**
	 * generates content of widget the widget.
	 * This renders the widget, if it is visible.
	 */
	public function renderContent()
	{
		if($this->visible) {
			$auditTrail = AuditTrail::model()->recently();
			$auditTrail->model = get_class($this->model);
			$auditTrail->model_id = $this->model->id;

			$evalUserLabel = $this->getEvalUserLabelCode();
			$this->widget('zii.widgets.grid.CGridView', array(
				'id'=>'audit-trail-grid',
				'dataProvider'=>$auditTrail->search(),
//				'filter'=>'',
				'columns'=>array(
					array(
						'name' => 'old_value',
						'filter' => '',
					),
					array(
						'name' => 'new_value',
						'filter' => '',
					),
					array(
						'name' => 'action',
						'filter'=> '',
					),
					array(
						'name' => 'field',
						'filter' => '',
					),
					array(
						'name' => 'stamp',
						'filter' => '',
					),
					array(
						'name' => 'user_id',
						'value'=>$evalUserLabel,
						'filter'=> '',
					),
					$this->getButtonColumn(),
				),
			));

		}
	}
	
	protected function getEvalUserLabelCode() {
		$userClass = $this->getFromConfigOrObject('userClass');
		$userNameColumn = $this->getFromConfigOrObject('userNameColumn');
		$userEvalLabel = ' ( ($t = '
							. $userClass
							. '::model()->findByPk($data->user_id)) == null ? "": $t->'
							. $userNameColumn
							. ' ) ';
		return $userEvalLabel;
	}
	
	protected function getFromConfigOrObject($value) {
		$at = Yii::app()->modules['auditTrail'];

		if( isset( $at[$value]) && !empty($at[$value] ) ) {
			return $at[$value];
		}
		
		$at = new AuditTrailModule();
		return $at->$value;
	}
	
	protected function getButtonColumn() {
		return array(
			'class'=>'CButtonColumn',
			'template' => '',
		);
	}
}